using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using RootPro.RootProCAD;
using RootPro.RootProCAD.Command;
using RootPro.RootProCAD.Geometry;

namespace RCAddInMeasureCS
{
    public partial class FormResult : Form
    {
        public FormResult()
        {
            InitializeComponent();

            //Jǉ܂
            listViewResult.Columns.Add("e");
            listViewResult.Columns.Add("茋");
            listViewResult.Columns.Add("݌v");

            //J̒
            listViewResult.Columns[0].Width = 120;
            listViewResult.Columns[1].Width = 120;
            listViewResult.Columns[2].Width = 120;

            comboBoxPrecision.SelectedIndex = 2;    //x̃ftHg 0.00
        }

        /// <summary>
        /// Ugڂǉ
        /// </summary>
        /// <param name="key"></param>
        /// <param name="result"></param>
        /// <returns></returns>
        public int AddResult(string key, double result)
        {
            double sum = 0.0;

            foreach (ListViewItem item1 in listViewResult.Items)
            {
                sum += (double)item1.SubItems[1].Tag; 
            }
            sum += result;
            int index = comboBoxPrecision.SelectedIndex;
            string text1 = string.Format("{0:F"+index.ToString()+"}", result);
            string text2 = string.Format("{0:F"+index.ToString()+"}", sum);

            //Xg̒ǉ
            ListViewItem item = listViewResult.Items.Add(key);
            item.SubItems.Add(text1);
            item.SubItems.Add(text2);

            item.SubItems[1].Tag = result;      //^Of[^ƂāATuACeɕێ

            return item.Index;
        }

        /// <summary>
        /// Rs[{^NbN̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCopy_Click(object sender, EventArgs e)
        {
            CopyResultData();
        }

        /// <summary>
        /// {^NbN̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        /// <summary>
        /// x̃R{{bNXύXCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void comboBoxPrecision_SelectedIndexChanged(object sender, EventArgs e)
        {
            //ׂĂ̍sXV
            double sum = 0.0;
            int index = comboBoxPrecision.SelectedIndex;

            foreach (ListViewItem item in listViewResult.Items)
            {
                double result = (double)item.SubItems[1].Tag;
                sum += result;

                string text1 = string.Format("{0:F" + index.ToString() + "}", result);
                string text2 = string.Format("{0:F" + index.ToString() + "}", sum);

//                item.SubItems[0].Text = item.SubItems[0].Text;
                item.SubItems[1].Text = text1;
                item.SubItems[2].Text = text2;
            }
        }

        /// <summary>
        /// ʂNbv{[hփRs[
        /// </summary>
        private void CopyResultData()
        {
            if (listViewResult.SelectedItems.Count == 0)
                return;

            String buffer = "";
            foreach (ListViewItem item in listViewResult.SelectedItems)
            {
                String line = "";
                for (int i = 0; i < item.SubItems.Count; i++)
                {
                    if (line.Length > 0)
                        line += "\t";       //؂蕶̒ǉ

                    line += item.SubItems[i].Text;
                }

                line += "\n";
                buffer += line;
            }

            //Nbv{[hփRs[
            Clipboard.SetText(buffer);
        }

        /// <summary>
        /// L[_Ȅ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void listViewResult_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Control && e.KeyCode == Keys.C)      // Ctrl+'C'
            {
                CopyResultData();
            }
        }

    }
}